using System;
using System.Collections.Generic;
using System.Text;

namespace CiaoClient
{
    [Serializable]
    public class ClientConfiguration
    {
        private bool hideWhenMinimized;
        private bool allowRsaEncryption;
        private bool requestRsaEncryption;
        private String reportServer;
        private int reportPort;

        public bool HideWhenMinimized
        {
            get { return hideWhenMinimized; }
            set { hideWhenMinimized = value; }
        }
        public bool AllowRsaEncryption
        {
            get { return allowRsaEncryption; }
            set { allowRsaEncryption = value; }
        }
        public bool RequestRsaEncryption
        {
            get { return requestRsaEncryption; }
            set { requestRsaEncryption = value; }
        }
        public String ReportServer
        {
            get { return reportServer; }
            set { reportServer = value; }
        }
        public int ReportPort
        {
            get { return reportPort; }
            set
            {
                if (value > 65535 || value < 1)
                {
                    throw new Exception("Port must be between 1 and 65535");
                }
                reportPort = value;
            }
        }

        public ClientConfiguration()
        {
            HideWhenMinimized = true;
            AllowRsaEncryption = true;
            RequestRsaEncryption = true;
            ReportServer = "e-aliki.dyndns.org";
            ReportPort = 3725;
        }
    }
}