using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Sockets;

namespace CiaoServer
{
    public class ConnectedClient
    {
        private Socket connectedSocket;
        private User connectedUser;
        private String publicKey;
        private String privateKey;
        private String tempKey;

        public Socket ConnectedSocket
        {
            get { return connectedSocket; }
            set { connectedSocket = value; }
        }
        public User ConnectedUser
        {
            get { return connectedUser; }
            set { connectedUser = value; }
        }
        public String PublicKey
        {
            get { return publicKey; }
            set { publicKey = value; }
        }
        public String PrivateKey
        {
            get { return privateKey; }
            set { privateKey = value; }
        }
        public String TempKey
        {
            get { return tempKey; }
            set { tempKey = value; }
        }
        public String EncryptedConnection
        {
            get
            {
                if (PublicKey != null && PrivateKey != null)
                {
                    return "Full";
                }
                else if (PublicKey != null)
                {
                    return "Server->Client";
                }
                else if (PrivateKey != null)
                {
                    return "Client->Server";
                }
                else
                {
                    return "None";
                }
            }
        }

        public ConnectedClient(Socket client)
        {
            ConnectedSocket = client;
            ConnectedUser = new User("Anonymous", "Anonymous@ciao.server", "", DateTime.Now);
        }
    }
}