using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace CiaoServer
{
    public partial class Options : Form
    {
        public ServerConfiguration ThisConfiguration;

        public Options(ServerConfiguration Conf)
        {
            InitializeComponent();
            ThisConfiguration = Conf;
            InitializeChangeEvents();
        }

        private void InitializeChangeEvents() {
            this.checkBox1.CheckedChanged +=new EventHandler(OptionsChange);
            this.checkBox2.CheckedChanged += new EventHandler(OptionsChange);
            this.checkBox3.CheckedChanged += new EventHandler(OptionsChange);
            this.textBox1.TextChanged +=new EventHandler(OptionsChange);
            this.textBox2.TextChanged += new EventHandler(OptionsChange);
            this.textBox3.TextChanged += new EventHandler(OptionsChange);
            this.textBox4.TextChanged += new EventHandler(OptionsChange);
            this.checkBox4.CheckedChanged += new EventHandler(OptionsChange);
            this.checkBox5.CheckedChanged += new EventHandler(OptionsChange);
        }

        private void OptionsChange(Object sender, EventArgs e)
        {
            this.button3.Enabled = true;
        }

        private void Options_Load(object sender, EventArgs e)
        {
            this.checkBox2.Checked = !this.checkBox2.Checked;
            this.checkBox3.Checked = !this.checkBox3.Checked;
            LoadConfiguration();
            this.button3.Enabled = false;
        }

        private void SaveConfiguration()
        {
            this.ThisConfiguration.HideWhenMinimized = this.checkBox1.Checked;
            this.ThisConfiguration.ReportError = this.checkBox2.Checked;
            this.ThisConfiguration.EMail = this.textBox1.Text;
            this.ThisConfiguration.SmtpServer = this.textBox4.Text;
            this.ThisConfiguration.UseAuthentication = this.checkBox3.Checked;
            this.ThisConfiguration.UserName = this.textBox2.Text;
            this.ThisConfiguration.Password = this.textBox3.Text;
            this.ThisConfiguration.AllowRsaEncryption = this.checkBox4.Checked;
            this.ThisConfiguration.RequestRsaEncryption = this.checkBox5.Checked;
        }

        private void LoadConfiguration()
        {
            this.checkBox1.Checked = this.ThisConfiguration.HideWhenMinimized;
            this.checkBox2.Checked = this.ThisConfiguration.ReportError;
            this.textBox1.Text = this.ThisConfiguration.EMail;
            this.textBox4.Text = this.ThisConfiguration.SmtpServer;
            this.checkBox3.Checked = this.ThisConfiguration.UseAuthentication;
            this.textBox2.Text = this.ThisConfiguration.UserName;
            this.textBox3.Text = this.ThisConfiguration.Password;
            this.checkBox4.Checked = this.ThisConfiguration.AllowRsaEncryption;
            this.checkBox5.Checked = this.ThisConfiguration.RequestRsaEncryption;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //OK
            SaveConfiguration();
            this.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //Cancel
            this.Close();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            //Apply
            SaveConfiguration();
            this.button3.Enabled = false;
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            this.groupBox1.Enabled = this.checkBox2.Checked;
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            this.groupBox2.Enabled = this.checkBox3.Checked;
        }
    }
}